#include <math.h>

extern "C" int _Export calcRate(double balance, double apr,
                                int days, double * charge)
{
  double rate = 0;
  rate = pow(1.0E+00 + (apr / 3.65E+02), days) -1.0E+00;
  *charge = balance * rate;
  return(0);
}

extern "C" int _Export applyRules(double balance, int days,
                                  double * charge)
{
  /* apply interest only if +ve balance over 5.00   */
  /* and at least 30 days old.                      */
  if (((5.0E+03 > balance) && (30 >= days))
        || (0.0E+00 >= balance)) {
    *charge = 0.0E+00;
  }
  /* apply minimum service charge if +ve balance    */
  /* and at least 90 days old.                      */
  if (((0.0E+00 < balance) && (90 <= days))
        && (1.0E+00 > *charge)) {
    *charge = 1.0E+00;
  }
  return(0);
}
